/**/
LEAVEPORTOPEN       = X2D(00000001)
OPENPORTSHARED      = X2D(00000002)
OPENWRITETHROUGH    = X2D(00000004)
ISPIPESERVER        = X2D(00000010)
ISPIPECLIENT        = X2D(00000020)
IGNORECARRIER       = X2D(00000040)

ISTELNETSERVER      = X2D(00000080)
ISTELNETCLIENT      = X2D(00000100)
ISSERIAL            = X2D(00000200)
ISSOCKETSERVER      = X2D(00000400)
ISSOCKETCLIENT      = X2D(00000800)
DELETECONNECTION    = X2D(00001000)

ARG Line

if RxFuncQuery("SysLoadFuncs") then do
   rc = RxFuncAdd("SysLoadFuncs","RexxUtil","SysLoadFuncs")
   rc = SysLoadFuncs()
end

ERR_NOSUCHNICK       = 401  /* "<nickname> :No such nick/channel"       */
ERR_NOSUCHSERVER     = 402  /* "<server name> :No such server"          */
ERR_NOSUCHCHANNEL    = 403  /* "<channel name> :No such channel"        */
ERR_CANNOTSENDTOCHAN = 404  /* "<channel name> :Cannot send to channel" */
ERR_TOOMANYCHANNELS  = 405  /* "<channel name> :You have joined too many
                                channels" */
ERR_WASNOSUCHNICK    = 406  /* "<nickname> :There was no such nickname" */
ERR_TOOMANYTARGETS   = 407  /* "<target> :Duplicate recipients. No message
                                delivered" */
ERR_NOORIGIN         = 409  /* ":No origin specified" */
ERR_NORECIPIENT      = 411  /* ":No recipient given (<command>)" */
ERR_NOTEXTTOSEND     = 412  /* ":No text to send" */
ERR_NOTOPLEVEL       = 413  /* "<mask> :No toplevel domain specified" */
ERR_WILDTOPLEVEL     = 415  /* "<mask> :Wildcard in toplevel domain" */
ERR_UNKNOWNCOMMAND   = 416  /* "<command> :Unknown command" */
ERR_NOMOTD           = 422  /* ":MOTD File is missing" */
ERR_NOADMININFO      = 423  /* "<server> :No administrative info available" */
ERR_FILEERROR        = 424  /* ":File error doing <file op> on <file>" */
ERR_NONICKNAMEGIVEN  = 431  /* ":No nickname given" */
ERR_ERRONEUSNICKNAME = 432  /* "<nick> :Erroneus nickname" */
ERR_NICKNAMEINUSE    = 433  /* "<nick> :Nickname is already in use" */
ERR_NICKCOLLISION    = 436  /* "<nick> :Nickname collision KILL" */
ERR_USERNOTINCHANNEL = 441  /* "<nick> <channel> :They aren't on that
                                channel" */
ERR_NOTONCHANNEL     = 442  /* "<channel> :You're not on that channel" */
ERR_USERONCHANNEL    = 443  /* "<user> <channel> :is already on channel" */
ERR_NOLOGIN           = 444 /* "<user> :User not logged in" */
ERR_SUMMONDISABLED    = 445 /* ":SUMMON has been disabled" */
ERR_USERSDISABLED     = 446 /* ":USERS has been disabled" */
ERR_NOTREGISTERED     = 451 /* ":You have not registered" */
ERR_NEEDMOREPARAMS    = 461 /* "<command> :Not enough parameters" */
ERR_ALREADYREGISTRED  = 462 /* ":You may not reregister" */
ERR_NOPERMFORHOST     = 463 /* ":Your host isn't among the privileged" */
ERR_PASSWDMISMATCH    = 464 /* ":Password incorrect" */
ERR_YOUREBANNEDCREEP  = 465 /* ":You are banned from this server" */
ERR_KEYSET            = 467 /* "<channel> :Channel key already set" */
ERR_CHANNELISFULL     = 471 /* "<channel> :Cannot join channel (+l)" */
ERR_UNKNOWNMODE       = 472 /* "<char> :is unknown mode char to me" */
ERR_INVITEONLYCHAN    = 473 /* "<channel> :Cannot join channel (+i)" */
ERR_BANNEDFROMCHAN    = 474 /* "<channel> :Cannot join channel (+b)" */
ERR_BADCHANNELKEY     = 475 /* "<channel> :Cannot join channel (+k)" */
ERR_NOPRIVILEGES      = 481 /* ":Permission Denied- You're not an IRC operator" */
ERR_CHANOPRIVSNEEDED  = 482 /* "<channel> :You're not channel operator" */
ERR_CANTKILLSERVER    = 483 /* ":You cant kill a server!" */
ERR_NOOPERHOST        = 491 /* ":No O-lines for your host" */
ERR_UMODEUNKNOWNFLAG  = 501 /* ":Unknown MODE flag" */
ERR_USERSDONTMATCH    = 502 /* ":Cant change mode for other users" */

ServerTextIds = "001 002 003 004 251 252 254 255 375 376 366 372 433"
MiscTexts     = "401 401 403 404 405 406 407 408 409 411 412 413 414 415 416 422 423 424 431 432 433 436 441 442 443 444 445 446 451 461 462 463 464 465 467 471 472 473 474 475 481 482 483 491 501 502"

HaveCR = 0
LogOn = 0
StoreString = ""
BeforeData = ""
tempdata = ""
MyLen = 0
NumJoined = 0
MakeNoise = 1
Novice = 1
PingMsg = 0
NormalScreen = 22
LineLen = 0
MoveUp = 0
atemp = ""

num = 0

/* setup DCC SEND Port for Listening! */

DisplayTimer = AdeptSetTimer(line, 1000)

AdeptComFlush(line)

Cr = d2c(13)
Lf = d2c(10)

Begin:

CrLf = d2c(13) || d2c(10)
         Input = ''
         LineLen = 0
         MoveUp = 0
         row = 0
         col = 0
         cmd = ""

         AdeptPrint(line, "[0m[2J\r\nChoose from the following servers:\r\n")
                     AdeptPrint(line, "---------------------------------\r\n")
                     AdeptPrint(line, " 1. irc.escape.com (NYC)         \r\n")
                     AdeptPrint(line, " 2. irc.texas.net (Texas-Net)    \r\n")
                     AdeptPrint(line, " 3. irc-2.mit.edu  (M.I.T.)      \r\n")
                     AdeptPrint(line, " 4. irc.ecn.uoknor.edu           \r\n")
                     AdeptPrint(line, " 5. cs-pub.bu.edu                \r\n")
                     AdeptPrint(line, "---------------------------------\r\n\n")
         Choice = AdeptInput(line,,1,,,"Choose: ",,,)

         Server = ''
         ServerPort = ''

         if(Choice = 1) then do
             Server = 'irc.escape.com'
             ServerPort = 6669
         end

         if(Choice = 2) then do
             Server = 'irc.texas.net'
             ServerPort = 6667
         end

         if(Choice = 3) then do
             Server = 'irc.sdsc.edu'
             ServerPort = 6667
         end

         if(Choice = 4) then do
             Server = 'irc.ecn.uoknor.edu'
             ServerPort = 6667
         end

        if(Choice = 6) then do
             Server = 'cs-pub.bu.edu'
             ServerPort = 6666
         end

        if(Choice = 7) then do
             Server = 'irc.pitt.edu'
             ServerPort = 6667
         end

        if(Choice = 8) then do
             Server = 'irc.colorado.edu'
             ServerPort = 6667
         end

        if(Choice = 9) then do
             Server = 'irc.texas.net'
             ServerPort = 6667
         end

         if(Server = '') then do
             exit
         end

         if(ServerPort = '') then do
             ServerPort = 6667
         end

         NickName = AdeptInput(line,,9,,,"[0m[K\r\n\n[KEnter Nickname to use: ",,,)

         if(Nickname = '') then do
             exit
         end

         Print(line, '[0m[2J[1;1H')
         Print(line, '57' || CrLf )
         Print(line, '56' || CrLf )
         Print(line, '55' || CrLf )
         Print(line, '54' || CrLf )
         Print(line, '53' || CrLf )
         Print(line, '52' || CrLf )
         Print(line, '51' || CrLf )
         Print(line, '50' || CrLf )
         Print(line, '49' || CrLf )
         Print(line, '48' || CrLf )
         Print(line, '47' || CrLf )
         Print(line, '46' || CrLf )
         Print(line, '45' || CrLf )
         Print(line, '44' || CrLf )
         Print(line, '43' || CrLf )
         Print(line, '42' || CrLf )
         Print(line, '41' || CrLf )
         Print(line, '40' || CrLf )
         Print(line, '39' || CrLf )
         Print(line, '38' || CrLf )
         Print(line, '37' || CrLf )
         Print(line, '36' || CrLf )
         Print(line, '35' || CrLf )
         Print(line, '34' || CrLf )
         Print(line, '33' || CrLf )
         Print(line, '32' || CrLf )
         Print(line, '31' || CrLf )
         Print(line, '30' || CrLf )
         Print(line, '29' || CrLf )
         Print(line, '28' || CrLf )
         Print(line, '27' || CrLf )
         Print(line, '26' || CrLf )
         Print(line, '25' || CrLf )
         Print(line, '24' || CrLf )
         Print(line, '23' || CrLf )
         Print(line, '22' || CrLf )
         Print(line, '21' || CrLf )
         Print(line, '20' || CrLf )
         Print(line, '19' || CrLf )
         Print(line, '18' || CrLf )
         Print(line, '17' || CrLf )
         Print(line, '16' || CrLf )
         Print(line, '15' || CrLf )
         Print(line, '14' || CrLf )
         Print(line, '13' || CrLf )
         Print(line, '12' || CrLf )
         Print(line, '11' || CrLf )
         Print(line, '10' || CrLf )
         Print(line, '9' || CrLf )
         Print(line, '8' || CrLf )
         Print(line, '7' || CrLf )
         Print(line, '6' || CrLf )
         Print(line, '5' || CrLf )
         Print(line, '4' || CrLf )
         Print(line, '3' || CrLf )
         Print(line, '2' || CrLf )
         Print(line, '1' || CrLf || Lf || '[s')
         Print(line, '[1;5H <---[u')

         ScreenSize = AdeptInput(line,,2,,,"What number is the arrow pointing at?  ",,,)

         if(ScreenSize = '') then do
             exit
         end

         TheirScreen = ScreenSize - 21

         UserReal = AdeptGetVar(line,1)
         NICK = NickName
         User = NickName
         Print(line, '[0m[2J[1;1H' || CrLf || Lf || 'Trying to connect to Internet Relay Chat server...' || CrLf)
         Print(line, 'This can take a few minutes...')

         rc = AdeptRawOpenSocket(ISSOCKETCLIENT, Server, ServerPort, 'Handle')

         if(rc = '-1' | rc = 65285 | rc = 65288) then do
           AdeptPrint(line, "\r\n\nCould not connect to server..\r\n")
           AdeptInput(line,,1,,,"\r\nPress [ENTER] to continue:",,,)
           exit
         end

         String = 'NICK ' || User || Crlf
         rc = AdeptRawComWrite(Handle, String, length(String), 'TRUE')

         if(rc = '-1' | rc = 65285 | rc = 65288) then do
           exit
         end

         String = 'USER ' || User || ' server.com AdeptIRC :' || UserReal || Crlf
         rc = AdeptRawComWrite(Handle, String, length(String), 'TRUE')

         if(rc = '-1' | rc = 65285 | rc = 65288) then do
           exit
         end

         String = 'JOIN #Adept' || CrLF
         rc = AdeptRawComWrite(Handle, String, length(String), 'TRUE')

         if(rc = '-1' | rc = 65285 | rc = 65288) then do
           exit
         end

         NumJoined = NumJoined + 1
         Channel.Numjoined = '#Adept'
         AdeptLocation(line, 'IRC Chat: ' || Channel.Numjoined)

         Stop = 0

         Input = ''
         LineLen = 0
         MoveUp = 0
         AdeptCls(line)

         pos = adeptcurpos(line)
         parse value pos with row col


         Print(line, '[1;1H*** Connected to server, waiting for it to initialize...' || CrLf)
         Print(line, '[24;1H[s')

/* Receives Data and Decides What do do with it! */

         Do Until (Cmd = 'SIGNOFF')

        AdeptDoLoop:

            if(MyLen > 0) then do
              BeforeData = StoreString
              StoreString = ""
              HaveCR = 0
            end
            Else
            do
              rc = AdeptRawComGetString(Handle, 'Data', 512, 10, 32, 'TRUE')

              if(rc > 65279 & rc \= 65292) then do
                rc = AdeptRawClose(Handle)
                exit
              end
            end

            HaveCR = 1

            if (HaveCR = 1) then do
               if (SUBSTR(Data,1,4) = 'PING') then do
                  PongData = 'PONG ' || Substr(data,6) || d2c(13) || d2c(10)
                  rc = AdeptRawComWrite(Handle, Pongdata, length(PongData), 'TRUE')
                  if(rc > 65279) then do
                    rc = AdeptRawClose(Handle)
                    exit
                  end
                  HaveCR = 0
                  SIGNAL AdeptDoLoop
               end
               if (SUBSTR(Data,2,4) = 'PING') then do
                  PongData = 'PONG ' || Substr(data,6) || d2c(13) || d2c(10)
                  rc = AdeptRawComWrite(Handle, Pongdata, length(PongData), 'TRUE')
                  if(rc > 65279) then do
                    rc = AdeptRawClose(Handle)
                    exit
                  end
                  HaveCR = 0
                  SIGNAL AdeptDoLoop
               end

               if(LogOn = 1 & data \= '') then do
                 rc = LINEOUT('LogFile.txt', Data)
               end
               parse value data with ':' From Num Dest Text
               parse value text with Remain ':' Msg
               parse value From with Nick '!' Addr .

               HaveCR = 0
               Data = ""

              if (wordpos(Num,ServerTextIds) <> 0) then do
                  Msg = STRIP(Msg,,d2c(10))
                  Msg = STRIP(Msg,,d2c(13))
                  DispText = '*** 'Msg
                  DispTextLength = LENGTH(DispText)
                  call ShowText
                  call UpdateBar
                  SIGNAL AdeptDoLoop
              end

              if (wordpos(Num,MiscTexts) <> 0) then do
                  Text = STRIP(Text,,d2c(10))
                  Text = STRIP(Text,,d2c(13))

                  DispText = '*** ' || Text

                  DispTextLength = LENGTH(DispText)
                  call ShowText
                  call UpdateBar
                  SIGNAL AdeptDoLoop
              end

              Select
                  When (Num = 'NICK') then do
                      Dest = strip(Dest,,d2c(10))
                      Dest = strip(Dest,,d2c(13))

                      DispText = '*** 'Nick 'is now known as 'SubStr(Dest,2)

                      DispText = strip(DispText,,d2c(10))
                      DispText = strip(DispText,,d2c(13))
                      DispTextLength = LENGTH(DispText)
                      call ShowText
                      call UpdateBar
                      SIGNAL AdeptDoLoop
                  end

                  When (Num = 'JOIN') then do
                      Destination = SUBSTR(Dest,2)
                      Destination = STRIP(Destination,,d2c(10))
                      Destination = STRIP(Destination,,d2c(13))

                      DispText = '*** 'Nick' ('Addr') Has Joined Channel 'SUBSTR(Dest,2)

                      DispText = strip(DispText,,d2c(10))
                      DispText = strip(DispText,,d2c(13))
                      DispTextLength = LENGTH(DispText)
                      call ShowText
                      call UpdateBar
                      SIGNAL AdeptDoLoop
                  end
                  When (Num = '311') then do
                      Parse value Text with MsgName Text
                      Text = STRIP(Text,,d2c(10))
                      Text = STRIP(Text,,d2c(13))
                      DispText = '*** ' || MsgName || ' is ' || text
                      DispText = strip(DispText,,d2c(10))
                      DispText = strip(DispText,,d2c(13))
                      DispTextLength = LENGTH(DispText)
                      call ShowText
                      call UpdateBar
                      SIGNAL AdeptDoLoop
                  end
                  When (Num = '319') then do
                      Parse value Text with Junk Text
                      Text = STRIP(Text,,d2c(10))
                      Text = STRIP(Text,,d2c(13))
                      DispText = '*** on channels ' || text
                      DispText = strip(DispText,,d2c(10))
                      DispText = strip(DispText,,d2c(13))
                      DispTextLength = LENGTH(DispText)
                      call ShowText
                      call UpdateBar
                      SIGNAL AdeptDoLoop
                  end
                  When (Num = '312') then do
                      Parse value Text with Junk Text
                      Text = STRIP(Text,,d2c(10))
                      Text = STRIP(Text,,d2c(13))
                      DispText = '*** on via server ' || text
                      DispText = strip(DispText,,d2c(10))
                      DispText = strip(DispText,,d2c(13))
                      DispTextLength = LENGTH(DispText)
                      call ShowText
                      call UpdateBar
                      SIGNAL AdeptDoLoop
                  end
                  When (Num = '317') then do
                      Parse value Text with MsgName Text
                      Text = STRIP(Text,,d2c(10))
                      Text = STRIP(Text,,d2c(13))
                      DispText = '*** ' || MsgName || ' has been idle ' || text
                      DispText = strip(DispText,,d2c(10))
                      DispText = strip(DispText,,d2c(13))
                      DispTextLength = LENGTH(DispText)
                      call ShowText
                      call UpdateBar
                      SIGNAL AdeptDoLoop
                  end
                  When (Num = 'MODE') then do
                      Text = STRIP(Text,,d2c(10))
                      Text = STRIP(Text,,d2c(13))
                      DispText = '*** Mode change 'text' on channel 'Destination' by 'nick
                      DispText = strip(DispText,,d2c(10))
                      DispText = strip(DispText,,d2c(13))
                      DispTextLength = LENGTH(DispText)
                      call ShowText
                      call UpdateBar
                      SIGNAL AdeptDoLoop
                  end

                  When (Num = 'QUIT') then do
                      Dest = strip(Dest,,d2c(10))
                      Dest = strip(Dest,,d2c(13))

                      Dest = strip(Dest,,d2c(10))
                      Dest = strip(Dest,,d2c(13))
                      Dest = strip(Dest,,':')

                      if(Dest <> '') then do
                          DispText = '*** Signoff: ' || Nick || ' (' || Dest || ' ' || Remain || ')'
                      end
                      Else
                          DispText = '*** Signoff: ' || Nick || ' (' || Nick || ')'

                      DispText = strip(DispText,,d2c(10))
                      DispText = strip(DispText,,d2c(13))
                      DispTextLength = LENGTH(DispText)
                      call ShowText
                      call UpdateBar
                      SIGNAL AdeptDoLoop
                  end

                  When (Num = 'PART') then do
                      Dest = strip(Dest,,d2c(10))
                      Dest = strip(Dest,,d2c(13))

                      DispText = '*** 'Nick' has left Channel #'SUBSTR(Dest,2)

                      DispText = strip(DispText,,d2c(10))
                      DispText = strip(DispText,,d2c(13))
                      DispTextLength = LENGTH(DispText)
                      call ShowText
                      call UpdateBar
                      SIGNAL AdeptDoLoop
                  end

                  when (Num = 'PRIVMSG') then do
                      if (SUBSTR(Msg,2,8) = 'DCC SEND') then do
                         Parse Value Msg with Junk1 Junk2 DccFilename RemoteAddr Port Size
                         Parse Value Size with Size ''
                         DispText = 'DCC SEND ( 'DccFilename') Received from 'nick
                         DispTextLength = LENGTH(DispText)
                         Call ShowText
                         iterate
                      end
                      if (SUBSTR(Msg,2,6) = 'ACTION') then do
                          Msg = strip(Msg,,d2c(10))
                          Msg = strip(Msg,,d2c(13))
                          Msg = strip(Msg,,d2c(1))
                          Msg = strip(Msg,,d2c(2))
                          Parse value Msg with Junk MsgText
                          DispText = '* ' || Nick || ' ' || MsgText
                          DispTextLength = LENGTH(DispText)

                          if(DispTextLength > 80) then do
                              Ident = '* '
                              IdentLen = LENGTH(Ident)
                              MiscText = Nick || ' ' || MsgText
                              MiscText = strip(MiscText,,d2c(10))
                              MiscText = strip(MiscText,,d2c(13))
                              MiscTextLength = LENGTH(MiscText)
                              call TextWithWrap
                              call UpdateBar
                              SIGNAL AdeptDoLoop
                          end
                          call ShowText
                          call UpdateBar
                          SIGNAL AdeptDoLoop
                      end
                      if (SUBSTR(Msg,2,5) = 'PING') then do
                        if(PingMsg = 1) then do
                            String = 'NOTICE ' || Nick || ' :' || PingText || CrLf
                            rc = AdeptRawComWrite(Handle, String, length(String), 'TRUE')
                        end
                        Else
                            String = 'NOTICE ' || Nick || ' :PONG' CrLf
                            rc = AdeptRawComWrite(Handle, String, length(String), 'TRUE')

                        DispText = '*** 'Nick' pinged you.'
                        DispText = strip(DispText,,d2c(10))
                        DispText = strip(DispText,,d2c(13))
                        DispTextLength = LENGTH(DispText)
                        call ShowText
                        MoveUp = 0
                        LineLen = 0
                        call UpdateBar
                        SIGNAL AdeptDoLoop
                      end
                      do
                          UDest = ATOUPPER(Dest)
                          UUser = ATOUPPER(User)

                          if(UDest = UUser) then do
                              IsPrivate = 1
                              if(MakeNoise = 0) then do
                                  UDest = '1'
                                  UUser = '0'
                                  PriIdent = '[0;1;44m*[0;44m'Nick'[0;1;44m*[0m '
                                  PriDispText = '[0;1;44m*[0;44m'Nick'[0;1;44m*[0m ' || Msg
                              end
                              Else
                              do
                                  PriIdent = '[0;1;44m*[0;44m'Nick'[0;1;44m*[0m '
                                  PriDispText = '[0;1;44m*[0;44m'Nick'[0;1;44m*[0m ' || Msg
                              end

                              DispText = '<'Nick'> ' || Msg
                          end
                          Else
                          do
                              IsPrivate = 0
                              DispText = '<'Nick'> ' || Msg
                          end

                          DispText = strip(DispText,,d2c(10))
                          DispText = strip(DispText,,d2c(13))
                          DispTextLength = LENGTH(DispText)

                          if(DispTextLength > 80) then do
                              Ident = '<'Nick'> '
                              IdentLen = LENGTH(Ident)
                              MiscText = Msg
                              MiscText = strip(MiscText,,d2c(10))
                              MiscText = strip(MiscText,,d2c(13))
                              MiscTextLength = LENGTH(MiscText)
                              call TextWithWrap
                              call UpdateBar
                              SIGNAL AdeptDoLoop
                           end
                           Else
                           do
                              if(IsPrivate = 1) then do
                                  Disptext = PriDispText
                                  IsPrivate = 0
                              end
                              call ShowText
                              call UpdateBar
                          end
                          SIGNAL AdeptDoLoop
                      end
                  end
                  when (Num = 'NOTICE') then do
                      do
                          if(Dest = User) then do
                              IsPrivate = 1
                              if(MakeNoise = 0) then do
                                  PriDispText = '[0;1;44m-[0;44m'Nick'[0;1;44m-[0m ' || Msg
                              end
                              Else
                                  PriDispText = '[0;1;44m-[0;44m'Nick'[0;1;44m-[0m ' || Msg

                              DispText = '<'Nick'> ' || Msg
                          end
                          else
                          do
                              IsPrivate = 0
                              DispText = '<'Nick'> ' || Msg
                          end

                          DispText = strip(DispText,,d2c(10))
                          DispText = strip(DispText,,d2c(13))
                          DispTextLength = LENGTH(DispText)

                          if(DispTextLength > 79) then do
    /*                          call DisplyWithWrap */
                               SIGNAL AdeptDoLoop
                           end
                           Else
                          do
                              if(IsPrivate = 1) then do
                                  Disptext = PriDispText
                                  IsPrivate = 0
                              end
                              call ShowText
                              call UpdateBar
                          end
                          SIGNAL AdeptDoLoop
                      end
                  end
                  when (Num = '353') then do
                      Remain = strip(Remain,,'=')
                      Remain = strip(Remain,,':')
                      Remain = strip(Remain,,' ')

                      DispText = '*** Users on 'Remain': ' || Msg
                      DispText = strip(DispText,,d2c(10))
                      DispText = strip(DispText,,d2c(13))
                      DispTextLength = LENGTH(DispText)

                      if(DispTextLength > 80) then do
                          Ident = '*** Users on 'Remain': '
                          IdentLen = LENGTH(Ident)
                          MiscText = Msg
                          MiscText = strip(MiscText,,d2c(10))
                          MiscText = strip(MiscText,,d2c(13))
                          MiscTextLength = LENGTH(MiscText)
                          call TextWithWrap
                          call UpdateBar
                          SIGNAL AdeptDoLoop
                      end
                      call ShowText
                      call UpdateBar
                      SIGNAL AdeptDoLoop
                  end
                  otherwise NOP
               end
            end


   KeyInput:

           Char = adepttimedinkey(line, 32)


           if (Char = 0) then do
               MyRet = AdeptTimerUp(line, DisplayTimer)
               if MyRet == 1 then
               do
                 UpdateBar()
               end
               call AdeptSleep line, 32
               SIGNAL AdeptDoLoop
            end
           if (Char = "-1") then do
               MyRet = AdeptTimerUp(line, DisplayTimer)
               if MyRet == 1 then
               do
                 UpdateBar()
               end
               call AdeptSleep line, 32
               SIGNAL AdeptDoLoop
            end
            if (Char = "-2") then do
                rc = AdeptRawClose(Handle)
                exit
            end
            if (Char = "-3") then do
               call AdeptSleep line, 32
               SIGNAL AdeptDoLoop
            end
            if (Char = "-4") then do
               call AdeptSleep line, 32
               SIGNAL AdeptDoLoop
            end
            if (Char = "-5") then do
               call AdeptSleep line, 32
               SIGNAL AdeptDoLoop
            end
            if (Char = "-6") then do
               call AdeptSleep line, 32
               SIGNAL AdeptDoLoop
            end
            if (Char = "-7") then do
               call AdeptSleep line, 32
               SIGNAL AdeptDoLoop
            end
            if (Char = 10 ) then do
               call AdeptSleep line, 32
               SIGNAL AdeptDoLoop
            end
            if (Char = 8) then do
               pos = adeptcurpos(line)
               parse value pos with row col

               if(LineLen \= 0) then do
                   LineLen = LineLen - 1

                   Input = Substr(input,1,(Length(Input) - 1))
                   Print(line, "[0m[u [s")
                   if(LineLen = 69 | LineLen = 129 | LineLen = 189) then do
                      MoveUp = MoveUp - 1

                      if(MoveUp \= 0) then do
                          InLen = LENGTH(Input)
                          MoveLen = 60 * MoveUp
                          EndLen = (InLen + 1) - MoveLen

                          Print(line, '[24;1H' || SUBSTR(Input, MoveLen, EndLen) || '[s[K')
                     end
                     Else
                          Print(line, '[24;1H' || Input || '[s[K')
                  end
               end
               Char = ''
               SIGNAL KeyInput
            end
            If (Char <> 0) then do
               if(LineLen < 256) then do
                   Letter = d2c(Char)
                   LineLen = LineLen + 1

                   print(line, '[0m[u' || Letter || '[s')
                   Input = Insert(Input,Letter)

                   if(LineLen = 70 | LineLen = 130 | LineLen = 190) then do
                      MoveUp = MoveUp + 1

                      InLen = LENGTH(Input)
                      MoveLen = 60 * MoveUp
                      EndLen = (InLen + 1) - MoveLen

                      Print(line, '[24;1H' || SUBSTR(Input, MoveLen, EndLen) || '[s[K')
                  end
               end
               Else
                  Print(line, '')

               if(Char \= 13) then do
                   Char = ''
                   SIGNAL KeyInput
               end
            end
            If (Char = 13) then Do
               if (Pos('/',Input) = 1) then do
                   adeptcurpos(line,23,0)
                   Print(line, "[s[0m[K")
                   Input = STRIP(input,,d2c(13))
                   parse Value Input with '/' Cmd Ops
                   MoveUp = 0
                   LineLen = 0
                   Input = ''
                  Select
                     When (Translate(Cmd) = 'SIGNOFF') then do
                        Parse value Ops with Op1
                        String = 'QUIT :' || Op1 || CRLF
                        rc = AdeptRawComWrite(Handle, String, length(String), 'TRUE')
                        rc = AdeptRawClose(Handle)
                        /* Push 'SIGNOFF' */
                        Return(4)
                     end
                     When (Translate(Cmd) = 'QUIT') then do
                        String = 'QUIT :' || 'Leaving...' || CRLF
                        rc = AdeptRawComWrite(Handle, String, length(String), 'TRUE')
                        rc = AdeptRawClose(Handle)
                        /* Push 'SIGNOFF' */
                        Return(4)
                     end
                     When (Translate(Cmd) = 'NICK') then do
                        Parse value Ops with Op1
                        String = ':' || NickName || ' NICK ' || Op1 || CRLF
                        rc = AdeptRawComWrite(Handle, String, length(String), 'TRUE')
                        SIGNAL AdeptDoLoop
                     end
                     When (Translate(Cmd) = 'NAMES') then do
                        Parse value Ops with Op1
                        if(Op1 <> '') then do
                            if(Op1 = '*') then do
                                 if(NumJoined = 0) then do
                                     String = 'NAMES '|| CrLf
                                     rc = AdeptRawComWrite(Handle, String, length(String), 'TRUE')
                                     SIGNAL AdeptDoLoop
                                 end
                                 Else
                                     String = 'NAMES ' || Channel.NumJoined || CrLf
                                     rc = AdeptRawComWrite(Handle, String, length(String), 'TRUE')
                                     SIGNAL AdeptDoLoop
                            end
                            String ='NAMES ' || Op1 || CrLf
                            rc = AdeptRawComWrite(Handle, String, length(String), 'TRUE')
                            SIGNAL AdeptDoLoopte
                        end
                        Else
                            if(NumJoined = 0) then do
                                String = 'NAMES '|| CrLf
                                rc = AdeptRawComWrite(Handle, String, length(String), 'TRUE')
                            end
                            Else
                                String = 'NAMES ' || Channel.NumJoined || CrLf
                                rc = AdeptRawComWrite(Handle, String, length(String), 'TRUE')
                                SIGNAL AdeptDoLoop
                     end
                     When (Translate(Cmd) = 'WHOIS') then do
                        Parse value Ops with Op1
                        if(Op1 <> '') then do
                            String = 'WHOIS ' || Op1 || CrLf
                            rc = AdeptRawComWrite(Handle, String, length(String), 'TRUE')
                        end
                        SIGNAL AdeptDoLoop
                     end
                     When (Translate(Cmd) = 'WHOWAS') then do
                        Parse value Ops with Op1
                        if(Op1 <> '') then do
                            String = 'WHOIS ' || Op1 || CrLf
                            rc = AdeptRawComWrite(Handle, String, length(String), 'TRUE')
                        end
                        SIGNAL AdeptDoLoop
                     end
                     When (Translate(Cmd) = 'RAW') then do
                        Parse value Ops with Op1
                        if(Ops <> '') then do
                            String = Ops || CrLf
                            rc = AdeptRawComWrite(Handle, String, length(String), 'TRUE')
                        end
                        SIGNAL AdeptDoLoop
                     end
                     When (Translate(Cmd) = 'HELP') then do
                            DispText = '**  -- Begin HELP for v0.0 --'
                            DispTextLength = LENGTH(DispText)
                            call ShowText
                            DispText = '**  /QUIT to QUIT'
                            DispTextLength = LENGTH(DispText)
                            call ShowText
                            DispText = '**  /LEAVE #Channel to leave a Channel'
                            DispTextLength = LENGTH(DispText)
                            call ShowText
                            DispText = '**  /JOIN #Channel (Remember the #) to join a Channel'
                            DispTextLength = LENGTH(DispText)
                            call ShowText
                            DispText = '**  /NAMES for a list of names in the current channel'
                            DispTextLength = LENGTH(DispText)
                            call ShowText
                            DispText = '**  /ME for a action command "/me smiles"'
                            DispTextLength = LENGTH(DispText)
                            call ShowText
                            DispText = '**  -- End HELP --'
                            DispTextLength = LENGTH(DispText)
                            call ShowText
                            call UpdateBar
                            SIGNAL AdeptDoLoop
                     end
                     When (Translate(Cmd) = 'NOVICE') then do
                        Parse value Ops with Op1
                        if(Op1 = 'ON' | Op1 = 'on') then do
                            Novice = 1
                            DispText = 'NOVICE Mode ON'
                            DispText = strip(DispText,,d2c(10))
                            DispText = strip(DispText,,d2c(13))
                            DispTextLength = LENGTH(DispText)
                            call ShowText
                            call UpdateBar
                            SIGNAL AdeptDoLoop
                        end
                        Else
                        if(Op1 = 'OFF' | Op1 = 'off') then do
                            Novice = 0
                            DispText = 'NOVICE Mode OFF'
                            DispText = strip(DispText,,d2c(10))
                            DispText = strip(DispText,,d2c(13))
                            DispTextLength = LENGTH(DispText)
                            call ShowText
                            call UpdateBar
                            SIGNAL AdeptDoLoop
                        end
                     end
                     When (Translate(Cmd) = 'LOG') then do
                        Parse value Ops with Op1
                        if(Op1 = 'ON' | Op1 = 'on') then do
                            LogOn = 1
                            DispText = 'Logging ON'
                            call ShowText
                            call UpdateBar
                            SIGNAL AdeptDoLoop
                        end
                        Else
                        if(Op1 = 'OFF' | Op1 = 'off') then do
                            LogOn = 1
                            DispText = 'Logging  OFF'
                            call ShowText
                            call UpdateBar
                            SIGNAL AdeptDoLoop
                        end
                     end
                     When (Translate(Cmd) = 'NOISE') then do
                        Parse value Ops with Op1
                        if(Op1 = 'ON' | Op1 = 'on') then do
                            DispText = 'NOISE is now ON'
                            DispText = strip(DispText,,d2c(10))
                            DispText = strip(DispText,,d2c(13))
                            DispTextLength = LENGTH(DispText)
                            call ShowText
                            call UpdateBar
                            MakeNoise = 1
                            SIGNAL AdeptDoLoop
                        end
                        Else
                        if(Op1 = 'OFF' | Op1 = 'off') then do
                            DispText = 'NOISE is now OFF'
                            DispText = strip(DispText,,d2c(10))
                            DispText = strip(DispText,,d2c(13))
                            DispTextLength = LENGTH(DispText)
                            call ShowText
                            call UpdateBar
                            MakeNoise = 0
                            SIGNAL AdeptDoLoop
                        end
                     end
                     When (Translate(Cmd) = 'PINGMSG') then do
                        Parse value Ops with Op1
                            PingMsg = 1
                            PingText = Op1
                            DispText = 'Ping response set to "' || PingText '"'
                            DispText = strip(DispText,,d2c(10))
                            DispText = strip(DispText,,d2c(13))
                            DispTextLength = LENGTH(DispText)
                            call ShowText
                            call UpdateBar
                            MakeNoise = 1
                            SIGNAL AdeptDoLoop
                        end
                     When (Translate(Cmd) = 'AWAY') then do
                        if(Ops <> '') then do
                            SetAway = 1
                            DispText = '*** You have been marked as away...'
                            String = 'AWAY :' || Ops || CrLF
                            rc = AdeptRawComWrite(Handle, String, length(String), 'TRUE')
                        end
                        Else
                        do
                            SetAway = 0
                            DispText = '*** You are no longer marked as away...'
                            String = 'AWAY' || CrLF
                            rc = AdeptRawComWrite(Handle, String, length(String), 'TRUE')
                        end
                        DispTextLength = LENGTH(DispText)
                        call ShowText
                        call UpdateBar
                        Input = ''
                        MoveUp = 0
                        LineLen = 0
                        SIGNAL AdeptDoLoop
                     end
                     When (Translate(Cmd) = 'JOIN') then do
                        Parse value Ops with Op1 Junk
                        String = 'JOIN '||Op1||CrLF
                        rc = AdeptRawComWrite(Handle, String, length(String), 'TRUE')
                        NumJoined = NumJoined + 1
                        Channel.Numjoined = Op1
                        MoveUp = 0
                        LineLen = 0
                        Input = ''
                        SIGNAL AdeptDoLoop
                     end
                     When (Translate(Cmd) = 'MSG') then do
                        Parse value Ops with Op1 RestMsg

                        RestMsg = STRIP(RestMsg,,d2c(10))
                        RestMsg = STRIP(RestMsg,,d2c(13))

                        String = 'PRIVMSG ' || Op1 ||' :'|| RestMsg || CrLf
                        rc = AdeptRawComWrite(Handle, String, length(String), 'TRUE')

                        IsPrivate = 1
                        PriIdent = '-> [0;1;44m*[0;44m' || Op1 '[0;1;44m*[0m '
                        PriDispText = RestMsg

                        Op1 = strip(Op1,,' ')

                        DispText = '-> *' || Op1 '* ' || RestMsg

                        DispText = STRIP(DispText,,d2c(10))
                        DispText = STRIP(DispText,,d2c(13))

                        DispTextLength = LENGTH(DispText)

                          if(DispTextLength > 80) then do
                              Ident = '-> *' || Op1 '* '
                              IdentLen = LENGTH(Ident)
                              MiscText = RestMsg
                              MiscText = strip(MiscText,,d2c(10))
                              MiscText = strip(MiscText,,d2c(13))
                              MiscTextLength = LENGTH(MiscText)
                              call TextWithWrap
                           end
                           Else
                           do
                              if(IsPrivate = 1) then do
                                  Disptext = PriIdent || PriDispText
                                  IsPrivate = 0
                              end
                              call ShowText
                          end

                        MoveUp = 0
                        LineLen = 0
                        input = ''
                        call UpdateBar
                        SIGNAL AdeptDoLoop
                     end
                     When (Translate(Cmd) = 'PING') then do
                        Parse value Ops with Op1 RestMsg

                        RestMsg = STRIP(RestMsg,,d2c(10))
                        RestMsg = STRIP(RestMsg,,d2c(13))

                        String = 'PRIVMSG ' || Op1 ||' PING' || CrLf
                        rc = AdeptRawComWrite(Handle, String, length(String), 'TRUE')

                        DispText = '-> Pinging ' || Op1
                        DispTextLength = LENGTH(DispText)
                        call ShowText
                        MoveUp = 0
                        LineLen = 0
                        input = ''
                        call UpdateBar
                        SIGNAL AdeptDoLoop
                     end

                     When (Translate(Cmd) = 'ME') then do
                        Msg = Ops
                        Msg = STRIP(Msg,,d2c(10))
                        Msg = STRIP(Msg,,d2c(13))

                        String = 'PRIVMSG ' || Channel.NumJoined || ' :' || 'ACTION ' || Msg || '' || CrLf
                        rc = AdeptRawComWrite(Handle, String, length(String), 'TRUE')

                        DispText = '* ' || User || ' '|| Msg
                        DispText = strip(DispText,,d2c(10))
                        DispText = strip(DispText,,d2c(13))
                        DispTextLength = LENGTH(DispText)
                        call ShowText
                        MoveUp = 0
                        LineLen = 0
                        input = ''
                        call UpdateBar
                        SIGNAL AdeptDoLoop
                     end
                     When (Translate(Cmd) = 'LEAVE') then do
                        Parse Value Ops with Op1 Junk
                        String  = 'PART ' || Op1 || CRLF
                        rc = AdeptRawComWrite(Handle, String, length(String), 'TRUE')
                        NumJoined = NumJoined - 1
                        if (NumJoined = 0) then NOP
                        Else do
                           TempNumJoined = NumJoined + 1
                           If (op1 = Channel.TempNumJoined) then NOP
                           else Do Counter = 1 to Numjoined
                              if (Channel.Counter <> Op1) then NOP
                              else do
                                 TempCount = Counter + 1
                                 TempChannel = Channel.Counter
                                 Channel.Counter = Channel.TempCount
                                 Channel.TempCount = TempChannel
                              end
                           end
                        end
                     MoveUp = 0
                     LineLen = 0
                     Input = ''
                     SIGNAL AdeptDoLoop
                     end
                     When (Translate(Cmd) = 'MODE') then do
                        Parse Value Ops with ChannelOp FlagOp Option
                        ModeData = 'MODE ' || ' ' || ChannelOP ||' ' || FlagOp || ' ' || Option || CRLF
                        Print(line,modedata)
                        adeptsleep(line,5000)
                        String = ModeData
                        rc = AdeptRawComWrite(Handle, String, length(String), 'TRUE')
                     end
                  otherwise do
                      MoveUp = 0
                      LineLen = 0
                      Input = ''
                  end
                  end
                end
                Else do
                  Input = STRIP(Input,,d2c(10))
                  Input = STRIP(Input,,d2c(13))

                  String = 'PRIVMSG ' || Channel.NumJoined || ' :' || Input || CrLf
                  rc = AdeptRawComWrite(Handle, String, length(String), 'TRUE')

                  NickName = strip(NickName,,d2c(32))
                  DispText = '<' || NickName || '> ' || input
                  DispText = strip(DispText,,d2c(10))
                  DispText = strip(DispText,,d2c(13))
                  DispTextLength = LENGTH(DispText)

                  if(DispTextLength > 80) then do
                      Ident = '<' || NickName || '> '
                      IdentLen = LENGTH(Ident)
                      MiscText = input
                      MiscText = strip(MiscText,,d2c(10))
                      MiscText = strip(MiscText,,d2c(13))
                      MiscTextLength = LENGTH(MiscText)
                      call TextWithWrap
                      MoveUp = 0
                      LineLen = 0
                      input = ''
                      call UpdateBar
                      SIGNAL AdeptDoLoop
                  end
                  call ShowText
                  MoveUp = 0
                  LineLen = 0
                  Input = ''
                  call UpdateBar
                  SIGNAL AdeptDoLoop
                end
            end
         end
      end
exit

UpdateBar:

  if(NumJoined = 0) then do
    AdeptLocation(line, 'IRC Chat')
    adeptprint(line, '[23;1H[0;30;47m' || COPIES(' ', 79) || '[23;1H {CR  type /HELP for HELP ' || SBytesSent || ' - ' || SBytesAck || ' - ' || GBytesAck || '[0m')

    if(MoveUp \= 0) then do
        InLen = LENGTH(Input)
        MoveLen = 60 * MoveUp
        EndLen = (InLen + 1) - MoveLen

        Print(line, '[24;1H' || SUBSTR(Input, MoveLen, EndLen) || '[s[K')
     end
     else
        Print(line, "[24;1H" || Input || '[s[K')

  end
  Else
  do
    AdeptLocation(line, 'IRC Chat: ' || Channel.Numjoined)
    adeptprint(line, '[23;1H[0;30;47m' || COPIES(' ', 79) || '[23;1H {CR  ' || Channel.Numjoined || ' type /HELP for HELP ' || SBytesSent || ' - ' || SBytesAck || ' - ' || GBytesAck || '[0m')

    if(MoveUp \= 0) then do
        InLen = LENGTH(Input)
        MoveLen = 60 * MoveUp
        EndLen = (InLen + 1) - MoveLen

        Print(line, '[24;1H' || SUBSTR(Input, MoveLen, EndLen) || '[s[K')
    end
    else
        Print(line, "[24;1H" || Input || '[s[K')
  end
  DisplayTimer = AdeptSetTimer(line, 8000)
return('')

ShowText:
  adeptcurpos(line, row, col)


  if(Row > 21) then do
      Print(line, '[23;1H[0m[K')
      Print(line, '[24;1H[K')
      Print(line, '[25;1H[K')
      AdeptPrint(line, '[23;1H\r\n')
      AdeptPrintL(line, '\n\n')

      CnvLine = AdeptConvert(line,'\r\n')

      do TheirScreen
          AdeptComWrite(line, CnvLine)
      end

      Print(line, '[22;1H')
  end

  Print(line, '[0m' || Cr || '[K' || DispText || '[K' || CrLf)

  pos = adeptcurpos(line)
  parse value pos with row col
return

TextWithWrap:
    CutBelow = 79 - IdentLen
    CutPos = LASTPOS(' ', MiscText, CutBelow)
    PString = SubStr(MiscText, 1, CutPos)

    if(IsPrivate = 1) then do
        DispText = PriIdent || PString
    end
    Else
    DispText = Ident || PString
    DispTextLength = LENGTH(DispText)

    call ShowText

    NewTextLen = MiscTextLength - CutPos
    MiscText = RIGHT(MiscText, NewTextLen)
    MiscText = strip(MiscText,,d2c(10))
    MiscText = strip(MiscText,,d2c(13))

    MiscTextLength = LENGTH(MiscText)

    TestIt = IdentLen  + MiscTextLength

    if(TestIt < 80) then do
        DispText = COPIES(' ', IdentLen) || MiscText
        DispTextLength = LENGTH(DispText)

        call ShowText
    end
    Else
    do
      CutBelow = 79 - IdentLen
      CutPos = LASTPOS(' ', MiscText, CutBelow)
      PString = SubStr(MiscText, 1, CutPos)

      DispText = COPIES(' ', IdentLen) || PString
      DispTextLength = LENGTH(DispText)

      call ShowText

      NewTextLen = MiscTextLength - CutPos
      MiscText = RIGHT(MiscText, NewTextLen)
      MiscText = strip(MiscText,,d2c(10))
      MiscText = strip(MiscText,,d2c(13))

      MiscTextLength = LENGTH(MiscText)

      TestIt = IdentLen  + MiscTextLength

      if(TestIt < 80) then do
          DispText = COPIES(' ', IdentLen) || MiscText
          DispTextLength = LENGTH(DispText)

          call ShowText
          return
      end
      Else
      do
        CutBelow = 79 - IdentLen
        CutPos = LASTPOS(' ', MiscText, CutBelow)
        PString = SubStr(MiscText, 1, CutPos)

        DispText = COPIES(' ', IdentLen) || PString
        DispTextLength = LENGTH(DispText)

        call ShowText

        NewTextLen = MiscTextLength - CutPos
        MiscText = RIGHT(MiscText, NewTextLen)
        MiscText = strip(MiscText,,d2c(10))
        MiscText = strip(MiscText,,d2c(13))

        MiscTextLength = LENGTH(MiscText)

        TestIt = IdentLen  + MiscTextLength

        if(TestIt < 80) then do
            DispText = COPIES(' ', IdentLen) || MiscText
            DispTextLength = LENGTH(DispText)

            call ShowText
            return
        end
        Else
        do
          CutBelow = 79 - IdentLen
          CutPos = LASTPOS(' ', MiscText, CutBelow)
          PString = SubStr(MiscText, 1, CutPos)

          DispText = COPIES(' ', IdentLen) || PString
          DispTextLength = LENGTH(DispText)
          call ShowText

          NewTextLen = MiscTextLength - CutPos
          MiscText = RIGHT(MiscText, NewTextLen)
          MiscText = strip(MiscText,,d2c(10))
          MiscText = strip(MiscText,,d2c(13))

          MiscTextLength = LENGTH(MiscText)

          TestIt = IdentLen  + MiscTextLength

          if(TestIt < 80) then do
              DispText = COPIES(' ', IdentLen) || MiscText
              DispTextLength = LENGTH(DispText)

              call ShowText
              return
          end
          Else
          do
            CutBelow = 79 - IdentLen
            CutPos = LASTPOS(' ', MiscText, CutBelow)
            PString = SubStr(MiscText, 1, CutPos)

            DispText = COPIES(' ', IdentLen) || PString
            DispTextLength = LENGTH(DispText)
            call ShowText
            return
          end
          return
        end
        return
      end
    end
return

ParseData:

 MyRet = POS(D2C(10), BeforeData)

 HaveCR = 0

 if(MyRet > 0) then do
   StoreString = StoreString || BeforeData
   BeforeData = ''
   Data = StoreString
   StoreString = ''
   HaveCR = 1
 end

return

